#!/usr/bin/perl
#!perl

use strict;
require 5.003;
use FindBin;
use lib $FindBin::Bin;
if ($ENV{'WINDIR'} ne undef) {
  chdir($FindBin::Bin);
}
use aolapi;
my $carturl = 'cart.pl';

print "Content-type: text/html\n\n";

my %INPUT;
my $cgiurl = $ENV{'SCRIPT_NAME'};
my @prods;
init();
header();
if (!aolapi::init()) {
  print "<b>Unable to initialize aolapi</b>";
} else {
  @prods = aolapi::listproducts();
  leftcol();
  rightcol();
}
footer();
exit;

#======================================================================= leftcol

sub leftcol {
print <<EOF;
<td width=200 bgcolor=#EAEAEA><br>
<ul>
EOF
  my @cats = aolapi::listcats();
  foreach my $catid (@cats) {
    my %cat = aolapi::getcat($catid);
    foreach my $prodid (@prods) {
      my %prod = aolapi::getproduct($prodid);
      if ($prod{'category'} ne $catid || $prod{'infourl'} eq undef) { next; }
      print "<li><a href=\"$cgiurl?cat=$catid\">$cat{'description'}</a></li>\n";
      last;
    }
  }
print <<EOF;
</ul>
</td>
<td width=1 bgcolor=#BABABA><img src=tr.gif width=1 height=1></td>
EOF
}
#====================================================================== rightcol

sub rightcol {
print <<EOF;
<td width=499 align=center>
<br>
<table border=0 width="100%" cellpadding="10">
EOF
  my $curcat = $INPUT{'cat'};
  if ($curcat eq undef) {
print <<EOF;
<tr><td>
<br><br>
<center>
<b>&lt;&lt; Select category</b>
</center>
<br><br>
</td></tr>
EOF
  } else {
    foreach my $id (@prods) {
      my %prod = aolapi::getproduct($id);
      if ($prod{'category'} ne $curcat || $prod{'infourl'} eq undef) { next; }
      my $imgurl = $prod{'image'};
      $imgurl = 'tr.gif' if $imgurl eq undef;
      my $price = sprintf("%.2f", $prod{'setup'});
print <<EOF;
<tr><td width="60%"><center>
<a href="$prod{'infourl'}" target=_blank><img src="$imgurl" border=0></a><br>
<a href="$prod{'infourl'}" target=_blank>$prod{'description'} - $price</a><br>
</center></td><td width="40%" valign=bottom>
<form method=POST action=$carturl>
<input type=hidden name=cmd value=add>
<input type=hidden name=fastadd value=on>
<input type=hidden name=referrer value="$ENV{SCRIPT_NAME}">
<input type=hidden name=prodid value=$id>
Add to cart&nbsp; <input type=text size=3 name=quantity value=1>
<input type=image name=add src="add.gif" border=0 height=18 width=18 alt="Add to cart">
</form>
</td></tr>
EOF
    }
  }
print <<EOF;
</table>
<br>
</td>
EOF
}
#======================================================================== header

sub header {
print <<EOF;
<html>
<head>
<title>ACME Virtual Storefront</title>
<style type="text/css">
 BODY, P, UL, LI, FORM, table, td
    {        font-family: arial; color: #444444;
        font-size: 14px;      }
 h3   {        font-size: 14 px; color: #444444;}
 .title    { font-family: Geneva, Arial, Helvetica, sans-serif; font-size: 18pt; color: #222222; font-weight: bold; }
 .form    { font-family: Geneva, Arial, Helvetica, sans-serif; font-size: 10pt; color: #444444; font-weight: bold; }
 .formsmall    { font-family: Geneva, Arial, Helvetica, sans-serif; font-size: 8pt; color: #444444;  }
 A:link{text-decoration: none; color: #39597D;}
 A:visited{text-decoration: none; color: #1C395B;}
 A:active{text-decoration: underline; color: #1C395B; font-weight: bold;}
 A:hover{text-decoration: underline; color: #1C395B;}
</style>
</head>
<body topmargin=10 leftmargin=20 marginheight=10" marginwidth=20>
<table width=702 cellpadding=0 cellspacing=0 border=0>
<tr>
<td width=1 bgcolor=#BABABA><img src=tr.gif width=1 height=1></td>
<td width=700>
<table width=700 cellpadding=0 cellspacing=0 border=0>
<tr>
<td bgcolor=#BABABA height=1><img src=tr.gif height=1 width=1></td>
</tr>
<tr>
<td bgcolor=#EAEAEA>
<table border=0 width="100%">
<tr><td width="70%">&nbsp;<span class=title>ACME Virtual Storefront</span></td>
<td width="15%">
<br>
<form method=post action=$carturl>
<input type=hidden name=template value=acmestoreviewcart.html>
<input type=image name=viewcart src="view_cart.gif" border=0 alt="View cart">
</form>
</td>
<td width="15%">
<br>
<form method=post action=$carturl>
<input type="hidden" name="cmd" value="viewcart">
<input type=hidden name=template value=acmestoreorderlogin.html>
<input type=image name=checkout src="check.gif" border=0 alt="Check out">
</form>
</td>
</tr></table>
</td>
</tr>
<tr>
<td bgcolor=#BABABA height=1><img src=tr.gif height=1 width=1></td>
</tr>
<tr>
<td>
<table width=700 cellpadding=0 cellspacing=0 border=0>
<tr>
EOF
}
#======================================================================== footer

sub footer {
print <<EOF;
</tr></table>
</td>
</tr>
<tr>
<td bgcolor=#BABABA height=1><img src=tr.gif height=1 width=1></td>
</tr>
</table></td>
<td width=1 bgcolor=#BABABA><img src=tr.gif width=1 height=1></td>
</tr></table>
</body>
</html>
EOF
}
#========================================================================== init

sub init {
  my @pairs = split(/&/, $ENV{'QUERY_STRING'});
  my $buffer;
  read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
  @pairs = (@pairs, split(/&/, $buffer));
  foreach my $pair (@pairs) {
    my ($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    if ($INPUT{$name} ne undef) { $INPUT{$name} = $INPUT{$name}.",".$value; }
    else { $INPUT{$name} = $value; }
  }
}
